function details() {    /* FritzOS 7.19 or later */
    var buf;
    var gw;
    var r1, r2, r3, r4;
    var result;
    var speed;
    var ovpn = "";
    var cname = "";
    var sname = "";

    // BE SURE that g_ip is valid

    if (g_ip == "0.0.0.0")
        g_ip = doLoadVar('shell?cmd=client');

    if (g_pinsip != 0)
        var pin = doLoadVar('shell?cmd=httpgetr+http://'+g_pinsip+'/pinn.php');

    if (g_wsmode == 0) {
        gw = location.hostname;
        r1 = doLoadVar("shell?cmd=dnsd+client+" + g_ip);
        g_ovpn = doLoadVar('shell?cmd=get+ovpn');
        cname = "Client " + g_ip + " " + doLoadVar("shell?cmd=nss+" + g_ip);
        sname = "Server " + gw + " " + doLoadVar("shell?cmd=nss+" + gw);
        buf = "<tt>" + r1 + "<br>" + cname +"<br>" + sname + "</tt>";

        if (g_ovpn == 1) {
            r2 = doLoadVar("shell?cmd=openvpn");
            r3 = doLoadVar("shell?cmd=route+vpn");
            var tmp = doLoadVar("shell?cmd=openvpn+check");
            r4 = tmp.replace("\n", "<br>");
            ovpn = "<tt>" + "<br>" + r2 + "<br>" + r3 + "<br>" + r4 + "</tt>";
        }
        else {
            var check = doLoadVar('shell?cmd=openvpn+check');
            var tmp = check.replace("\n", "<br>");
            var tmp2 = tmp.replace("\n", "<br>");
            ovpn = "<tt>" + "<br>" + tmp2 + "</tt>";
        }
    }
    else {
        gw = doLoadVar('shell?cmd=get+wip');
        cname  = doLoadVar('shell?cmd=wnss+' + g_ip);
        sname = "Server " + gw + " " + doLoadVar("shell?cmd=wnss+" + gw);
        buf = "<tt>" + "Client " + g_ip + cname + "<br>" + sname + "</tt>";
    }
	result = GetFbDetails(g_ip);
	if (result)
			buf += "<br><tt>" + result + "</tt>";
    if (pin)
        buf += "<tt><br>PIN "+pin+"</tt>";
    buf += ovpn;
    return buf;
}

function GetFbHosts(el) {  /* FritzOS 7.19 */
    var obj = document.getElementById(el);
    var i, result = "";
    var fbp = doLoadVar('shell?cmd=get+fbpwd');
    if (fbp == "\n")
        return null;

    var fbx = doLoadVar('shell?cmd=get+fbips');
    if (fbx == "\n")
        return null;

    alert("TESTING: Update for FritzOS 7.28");

    alert(topoData.topology.rootuid);

    return null;

    var fbj = doLoadVar('shell?cmd=xml+sh+fb7590');
    if (fbj.search("ERROR") >= 0)
        return null;
    if (fbj.search("Invalid") >= 0)
        return null;
    var fb   = JSON.parse(fbj);
    var fbn  = fb.data.active.length;
    var fbnh = fb.data.active;
    var txt = "<br>Active Hosts: " + fbn + "<br>";

    for (i=0; i<fbn; i++)
        txt += fb.data.active[i].name + " " + fb.data.active[i].ipv4.ip + " " + fb.data.active[i].mac + "<br>";


    fbn  = fb.data.passive.length;
    fbnh = fb.data.passive;
    txt += "<br>Passive Hosts: " + fbn + "<br>";

    for (i=0; i<fbn; i++)
        txt += fb.data.passive[i].name + " " + fb.data.passive[i].ipv4.ip + " " + fb.data.passive[i].mac + "<br>";

    obj.innerHTML = txt;
    return i;
}

function GetFbDsl() {   /* FritzOS 7.27 */
    var result = "ERROR";
    var fbj = doLoadVar('shell?cmd=xml+sh+fb7590d');
    if (fbj.search("ERROR") >= 0)
        return null;
    if (fbj.search("Invalid") >= 0)
        return null;
    if (fbj) {
        var fb = JSON.parse(fbj);
        if (fb) {
            var down = fb.data.connectionData.dsRate;
            var up   = fb.data.connectionData.usRate;
            var upt  = fb.data.connectionData.line[0].time;
            result = "DSL &darr;" + down + " &uarr;" + up + "<br>Uptime " + upt;
        }
    }
    return result;
}

function GetFbWlan(ip) {
    var us = 0;
    var ds = 0;
    var ws = "";
    var go = true;
    function echo(item, index) {
        if (go && item.ip == ip) {
            if (item.bands.ghz5) {
                ds = item.bands.ghz5.rate.ds;
                us = item.bands.ghz5.rate.us;
                ws = "5 Ghz";
                go = false;
            }
            else
            if (item.bands.ghz24) {
                ds = item.bands.ghz24.rate.ds;
                us = item.bands.ghz24.rate.us;
                ws = "2.4 Ghz";
                go = false;
            }
        }
    }
    var result = "ERROR";
    var fbj = doLoadVar('shell?cmd=xml+sh+fb7590w');
    if (fbj.search("ERROR") >= 0)
        return null;
    if (fbj.search("Invalid") >= 0)
        return null;
    if (fbj) {
        var fb = JSON.parse(fbj);
        if (fb) {
            fb.data.wlanSettings.knownWlanDevices.forEach(echo);
            if (ws != "")
                result = ws +" WiFi " + ds + "/" + us + " Mbps";
            else
                result = "LAN connection";
        }
    }
    return result;
}

function GetFbWlanX(ip) {
    var us = 0;
    var ds = 0;
    var ws = "";
    var result = "ERROR";
    var h = doLoadVarN('shell?cmd=dot2ip+'+ip);
    if (h == result)
        return result;
    var fbj = doLoadVar('shell?cmd=xml+sh+fb7590wx');
    if (fbj.search("ERR") >= 0)
        return result;
    if (fbj.search("Invalid") >= 0)
        return result;
    if (fbj) {
        var fb = JSON.parse(fbj);
        if (fb) {
            for (var x in fb.topology.devices) {
                var el = fb.topology.devices[x];
                if (el.ipinfo && el.ipinfo[1] == ip) {
                    if (el.conn == "lan")
                        return el.conninfo[0].desc + " at " + el.conninfo[0].speed;
                    if (el.conn == "any")
                        return el.nameinfo.name;
                    ws = el.conninfo[0].desc;
                    ds = el.conninfo[0].speed_tx;
                    us = el.conninfo[0].speed_rx;
                    return  ws +" WiFi " + ds + "/" + us + " Mbps";
                }
            }
        }
    }
    return result;
}




function GetFbHn(ip) {   /* FritzOS 7.27 */
    var result = "ERROR";
    var fbh = doLoadVar('shell?cmd=xml+sh+fb7590hn');
    if (fbh.search("ERROR") >= 0)
        return null;
    if (fbh.search("Invalid") >= 0)
        return null;
    if (fbh) {
        var ix1 = fbh.search('{"topology":');
        var ix2 = fbh.search('}}}}');
        var fbj = fbh.slice(ix1, ix2+5);
        var fb  = JSON.parse(fbj);
        if (fb) {
            for (let x in fb.topology.devices) {
                if (fb.topology.devices[x].ipinfo) {
                    if (fb.topology.devices[x].ipinfo[1] == ip) {
                        result = fb.topology.devices[x].conninfo[0].desc;
                        return result;
                    }
                }
            }
        }
    }
    return result;
}


















function GetFbHnOld(ip) {   /* FritzOS 7.28 */

    for (let x in topoData.topology.devices) {
        if (topoData.topology.devices[x].ipinfo) {
            if (topoData.topology.devices[x].ipinfo[1] == ip) {
                result = topoData.topology.devices[x].nameinfo.name;
                return "Name: " + result +  " [" + ip + "]";
            }
        }
    }
    return "Client IP: " + g_ip;
}

function GetFbTemp(el) {   /* FritzOS 7.19 */
    var obj = document.getElementById(el);
    var txt = obj.innerHTML;

    var fbp = doLoadVar('shell?cmd=get+fbpwd');
    if (fbp == "\n")
        return null;

    var fbx = doLoadVar('shell?cmd=get+fbips');
    if (fbx == "\n")
        return null;

    var fbj = doLoadVar('shell?cmd=xml+sh+fb7590t');
    if (fbj.search("ERROR") >= 0)
        return null;
    if (fbj.search("Invalid") >= 0)
        return null;
    var fb = JSON.parse(fbj);
    var result = fb.data.devices[0].units[0].skills[0].currentInCelsius;
    txt += "<b>" + result + "</b>" + " Hallway";
    obj.innerHTML = txt;
    return result;
}

function GetFbSet() {   /* FritzOS 7.19 */
    var result;
    var fbp = doLoadVar('shell?cmd=get+fbpwd');
    if (fbp == "\n")
        return null;

    var fbx = doLoadVar('shell?cmd=get+fbips');
    if (fbx == "\n")
        return null;

    result = doLoadVar('shell?cmd=xml+sh+fb_set');
    return result;
}

function GetFbLog(n) {  /* FritzOS 7.19  n is the number of entries to fetch */
    var fbp = doLoadVar('shell?cmd=get+fbpwd');
    if (fbp == "\n")
        return null;

    var fbx = doLoadVar('shell?cmd=get+fbips');
    if (fbx == "\n")
        return null;

    var fbj = doLoadVar('shell?cmd=xml+sh+fb_log');
    if (fbj.search("ERROR") >= 0)
        return null;
    if (fbj.search("Invalid") >= 0)
        return null;
    var fb = JSON.parse(fbj);
    var result = "";
    var len = fb.data.log.length;
    for (i=0; i<len; i++) {
        if (i == n)
            break;
        result += fb.data.log[i][0] + " " + fb.data.log[i][1] + " " + fb.data.log[i][2] + "<br>";
    }
    return result;
}

function GetFbDetails(ip) {
    var result = ip + " not found";
    var dsl  = GetFbDsl();
    var wlan = GetFbWlanX(ip);

/*  Optional G225 support
    var down, up, uptime;
    uptime = doLoadVar('shell?cmd=snmpget+1.3.0');
    if (uptime.search('response') >= 0)
        result += uptime +'<br>';
    else {
        down = doLoadVar('shell?cmd=snmpget+10.97.1.1.2.1.10.1');
        up   = doLoadVar('shell?cmd=snmpget+10.97.1.1.2.1.10.2');
        var tmp = uptime.split(" ");
        result += down.substr(28) + 'kbps &darr;<br>' + up.substr(28) + 'kbps &uarr;<br>' + 'Uptime ' + tmp[4] + ' ' + tmp[5];
    }
*/
    result = dsl + "<br>" + wlan;
    return result;
}

function GetHueLights(el) {
    var obj = document.getElementById(el);
    var txt = "HUE Lights: ";
    var i = 0, x;
    var username = doLoadVarN('shell?cmd=get+hueUser');
    if (!username)
        return 0;

    var ip = doLoadVarN('shell?cmd=get+hueIP');
    if (!ip)
        return 0;
    var hueurl = 'http://'+ip+'/api/'+username+'/lights';
    var huej = doLoadVar('shell?cmd=httpgetr '+hueurl);
    if (huej.search("SYSERR") >= 0)
        return 0;
    var hue = JSON.parse(huej);
    for (x in hue) {
        if (hue[x].state.on) {
            txt += "<b>" + x + "</b> ";
            i++;
        }
        else
            txt += x + " ";
    }
    if (i == 0)
        txt += "[All OFF]";
    else
        txt += "[" + i + " ON]";
    obj.innerHTML = txt;
    return i;
}

function GetHueTemp(el) {
    var obj = document.getElementById(el);
    var txt = "";
    var i = 0, x;
    var username = doLoadVarN('shell?cmd=get+hueUser');
    if (!username)
        return 0;

    var ip = doLoadVarN('shell?cmd=get+hueIP');
    if (!ip)
        return 0;
    var hueurl = 'http://'+ip+'/api/'+username+'/sensors';
    var huej = doLoadVar('shell?cmd=httpgetr '+hueurl);
    if (huej.search("SYSERR") >= 0)
        return 0;

    var hue = JSON.parse(huej);
    for (x in hue) {
        if (hue[x].state.temperature) {
            var name = "";
            switch (i) {
                case 0: name = "Office";
                        break;
                case 1: name = "Terrace";
                        break;
                case 2: name = "Laundry";
                        break;
                case 3: name = "Front Door";
                        break;
            }
            txt += "<b>" + hue[x].state.temperature/100 + "</b> " + name + "<br>";
            i++;
        }
    }
    obj.innerHTML = txt;
    return i;
}

function GetHueBridgeIP() {
    var ip = doLoadVarN('shell?cmd=get+hueIP');
    if (!ip || ip == '0.0.0.0') {
        var huej = doLoadVar('shell?cmd=url+http://discovery.meethue.com');
        huej = huej.replace('[', ' ');
        huej = huej.replace(']', ' ');
        var hue = JSON.parse(huej);
        return hue.internalipaddress;
    }
    return ip;
}

function PiHole(op) {
    if (g_phips == "0.0.0.0")
        return "ERROR: not configured";

    var p = doLoadVar('shell?cmd=probe+'+g_phips+':'+g_phport);
    if (p.search("FAIL") >= 0)
        return p;

    var v = 'shell?cmd=httpgetr+http://'+g_phips+'/admin/api.php?'+op+'&auth='+g_phauth;
    var phj = doLoadVar(v);
    var phs = JSON.parse(phj);
    return phs.status;
}


function CheckboxOnOff(item, cmd) {
    if (item.checked)
        location.href="app?cmd="+cmd+"+on";
    else
        location.href="app?cmd="+cmd+"+off";
}

function CheckboxOnOffX(item, cmd, flag) {
    if (item.checked)
        location.href="app?cmd="+cmd+"+on+"+flag;
    else
        location.href="app?cmd="+cmd+"+off";
}

function CheckboxOpenClose(item, cmd) {
    if (item.checked)
        location.href="app?cmd="+cmd+"+open";
    else
        location.href="app?cmd="+cmd+"+close";
}

function ShowConsole() {
    var url=location.href;
    var x = doLoadVar('shell?cmd=get+visible');
    if (x == 0) {
        alert('No open windows!');
        return false;
    }
    else {
        location.href='shell?cmd=show';
        alert('The NAT32 Console should now be visible');
    }
    location.href=url;
    return true;
}

function CheckboxGet(item) {
    var x = document.getElementById(item);
    x.checked = state;
    return;
}

function CheckboxSet(item, state) {
    var x = document.getElementById(item);
    x.checked = state;
    return;
}

function SetResult(buf) {
    result = buf;
    return result;
}

function GetResult(buf) {
    buf = window.top.result
    return buf;
}

function AlertResult(buf) {
    buf = window.top.result
    alert(buf);
    return buf;
}

function SetResultRaw(buf) {
    result = buf;
    return result;
}

function Updated() {
    return;
    var d = new Date(document.lastModified);
    utc = d.getTime() + (d.getTimezoneOffset() * 60000);
    nd = new Date(utc);
    document.write(nd);
}

function debug(tag) {
    var s = document.getElementsByTagName(tag);
    var n = s.length;
    for (i=0; i<n; i++) {
        if (s[i].src)
            alert(s[i].src);
        else
            alert(s[i].innerHTML);
    }
}

function write(txt) {
    var s = document.getElementById('Data');
    s.innerText += txt;
}

function id_write(txt, id) {
    var s = document.getElementById(id);
    if (s) {
        if (s.innerText)
            s.innerText = txt;
        else
            s.value = txt;
    }
    else
        alert(id + " not found");
}

function id_write_html(txt, id) {
    var s = document.getElementById(id);
    if (s) {
        if (s.innerHTML)
            s.innerHTML = txt;
        else
            s.value = txt;
    }
    else
        alert(id + " not found");
}

function id_write_red(txt, id) {
    var s = document.getElementById(id);
    if (s) {
        if (s.innerHTML)
            s.innerHTML = "<font color='red'>" + txt + "</font>";
        else
            s.value = txt;
    }
    else
        alert(id + " not found");
}

function id_write_black(txt, id) {
    var s = document.getElementById(id);
    if (s) {
        if (s.innerHTML)
            s.innerHTML = "<font color='black'>" + txt + "</font>";
        else
            s.value = txt;
    }
    else
        alert(id + " not found");
}

function id_write_pre(txt, id) {
    var s = document.getElementById(id);
    if (s) {
        if (s.innerHTML)
            s.innerHTML = "<pre>"+txt+"</pre>";
        else
            s.value = txt;
    }
    else
        alert(id + " not found");
}

function id_append_text(txt, id) {
    var s = document.getElementById(id);
    if (s)
        s.innerText += txt;
    else
        alert(id + " not found");
}

function id_append_html(txt, id) {
    var el = document.getElementById(id);
    if (el) {
        el.innerHTML += txt;
        el.scrollTop = el.scrollHeight;
    }
    else
        alert(id + " not found");
}

function id_append_red(txt, id) {
    var el = document.getElementById(id);
    if (el) {
        el.innerHTML += "<span style='background-color:white; color:red'>" + txt + "</span>";
        el.scrollTop = el.scrollHeight;
    }
    else
        alert(id + " not found");
}

function id_append_black(txt, id) {
    var el = document.getElementById(id);
    if (el) {
        el.innerHTML += "<span style='background-color:white; color:black'>" + txt + "</span>";
        el.scrollTop = el.scrollHeight;
    }
    else
        alert(id + " not found");
}

function id_append_img(f, id) {
    var el = document.getElementById(id);
    if (el) {
        el.innerHTML += "<img src="+f+">";
        el.scrollTop = el.scrollHeight;
    }
    else
        alert(id + " not found");
}

function clear() {
    var s = document.getElementById('Data');
    s.innerText = "";
}

function message(x) {
    id_write(x, 'input3');
    return 1;
}

