// XML request object constructor

function XMLDoc() {
    var me = this;
    var req = null;

    if (window.XMLHttpRequest) {
        try {
            req = new XMLHttpRequest();
        } catch(e) {
            req = null;
        }
    } else if (window.ActiveXObject) {
        try {
            req = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            try {
               req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) {
               req = null;
            }
        }
    } else {
            alert("ERROR: Your browser does not support XML")
    }
    this.request = req;
    this.loadXMLDoc = function(url, loadHandler) {
        if (this.request) {
            this.request.open("GET", url, true);
            this.request.onreadystatechange = function () {loadHandler(me)};
            this.request.setRequestHeader("Content-Type", "text/xml");
            this.request.send("");
        }
    };
}

function doLoad(url, handler) {
    var obj = new XMLDoc();
    obj.loadXMLDoc(url, handler);
}

function processReqChange() {
   // only if req shows "loaded"
   if (req.readyState == 4) {
        // only if "OK"
        if (req.status == 200) {
            doSuccess();
        } else {
            doFailure();
        }
    }
}

function doSuccess() {
    res = req.responseXML;
    obj = document.getElementById(data);
    if (obj)
        obj.innerHTML = "<pre>" + res.getElementsByTagName('Data')[0].firstChild.nodeValue +"</pre>";
    elapsed = 0;
}

function doFailure() {
    res = req.responseXML;
    obj = document.getElementById(data);
    if (obj)
        obj.lastChild.nodeValue = 'empty';
    elapsed = 0;
}

