var period = 30;
var elapsed = 0;

function doLoad() {
   CheckSession();
   setInterval( "CheckSession()", period*1000 );
   setInterval( "Counter()", 1000 );
}

function Counter() {
   if (period-elapsed) {
      elapsed = elapsed + 1 ;
      document.counter.seconds.value = (period-elapsed);
   } else {
      elapsed = 0;
   }
}

function CheckSession() {
    try {
        loadXMLDoc("SESSION_DATA.php");
    } catch(e) {
       alert("CHECK.JS Error: " + e);
    }
}

function loadXMLDoc(url) {
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
		req.open("GET", url, true);
		req.send(null);
	} else if (window.ActiveXObject) {
        isIE = true;
        req = new ActiveXObject("Microsoft.XMLHTTP");
        if (req) {
		    req.onreadystatechange = processReqChange;
			req.open("GET", url, true);
			req.send();
		}
    }
}

function processReqChange() {
   // only if req shows "loaded"
   if (req.readyState == 4) {
        // only if "OK"
		if (req.status == 200) {
            printSuccess();
        } else {
            printFailure();
        }
	}
}

function printSuccess() {
    res = req.responseXML;
    document.getElementById("session").lastChild.nodeValue = 'Active';
    document.getElementById("location").lastChild.nodeValue = res.getElementsByTagName('location')[0].firstChild.nodeValue;
    document.getElementById("signal_strength").lastChild.nodeValue = res.getElementsByTagName('signal_strength')[0].firstChild.nodeValue;
    document.getElementById("signal_quality").lastChild.nodeValue = res.getElementsByTagName('signal_quality')[0].firstChild.nodeValue;
    document.getElementById("bytes_in").lastChild.nodeValue = res.getElementsByTagName('bytes_in')[0].firstChild.nodeValue;
    document.getElementById("bytes_out").lastChild.nodeValue = res.getElementsByTagName('bytes_out')[0].firstChild.nodeValue;
    elapsed = 0;
}

function printFailure() {
	res = req.responseXML;
	document.getElementById("session").lastChild.nodeValue = 'Inactive';
	document.getElementById("location").lastChild.nodeValue = "Unknown";
	document.getElementById("signal_strength").lastChild.nodeValue = "No signal";
	document.getElementById("signal_quality").lastChild.nodeValue = "No signal";
    elapsed = 0;
}
